Debian Bug report logs - #435662
apt: wants to install more packages even if the dependencies are satisfied

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Luca Capello <luca@pca.it>

Date: Thu, 2 Aug 2007 12:15:06 UTC

Severity: normal

Found in version apt/0.7.5

Fixed in version 0.7.26~exp8

Done: David Kalnischkies <kalnischkies@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Luca Capello <luca@pca.it>, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
New Bug report received and forwarded. Copy sent to Luca Capello <luca@pca.it>, APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apt: wants to install more packages even if the dependencies are satisfied
Date: Thu, 02 Aug 2007 12:42:37 +0200
Package: apt
Version: 0.7.5
Severity: normal

Hello,

I'm sorry this bug is quite old (but still present in an updated sid),
but I tried to better debug it without success.  The output is quite
self-explicative: xserver-xorg-input-mouse, xserver-xorg-input-kbd and
xserver-xorg-video-intel should be enough to satisfy xserver-xorg
Depends: on "xserver-xorg-video-all | xserver-xorg-video-1.0,
xserver-xorg-input-all | xserver-xorg-input".

--8<---------------cut here---------------start------------->8---
Script started on Sat 02 Jun 2007 11:05:22 PM CEST
gismo:~# apt-get install xserver-xorg-input-mouse xserver-xorg-input-kbd xserver-xorg-video-intel
Reading package lists... Done
Building dependency tree... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-video-all xserver-xorg-video-apm xserver-xorg-video-ark xserver-xorg-video-ati
  xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-cyrix xserver-xorg-video-dummy
  xserver-xorg-video-fbdev xserver-xorg-video-glint xserver-xorg-video-i128 xserver-xorg-video-i810 xserver-xorg-video-mga
  xserver-xorg-video-neomagic xserver-xorg-video-nv xserver-xorg-video-rendition xserver-xorg-video-s3
  xserver-xorg-video-s3virge xserver-xorg-video-savage xserver-xorg-video-siliconmotion xserver-xorg-video-sis
  xserver-xorg-video-sisusb xserver-xorg-video-tdfx xserver-xorg-video-tga xserver-xorg-video-trident xserver-xorg-video-tseng
  xserver-xorg-video-v4l xserver-xorg-video-vesa xserver-xorg-video-vga xserver-xorg-video-via xserver-xorg-video-vmware
  xserver-xorg-video-voodoo
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable
Recommended packages:
  xserver-xorg-input-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-kbd xserver-xorg-input-mouse xserver-xorg-video-all xserver-xorg-video-apm
  xserver-xorg-video-ark xserver-xorg-video-ati xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-cyrix
  xserver-xorg-video-dummy xserver-xorg-video-fbdev xserver-xorg-video-glint xserver-xorg-video-i128 xserver-xorg-video-i810
  xserver-xorg-video-intel xserver-xorg-video-mga xserver-xorg-video-neomagic xserver-xorg-video-nv
  xserver-xorg-video-rendition xserver-xorg-video-s3 xserver-xorg-video-s3virge xserver-xorg-video-savage
  xserver-xorg-video-siliconmotion xserver-xorg-video-sis xserver-xorg-video-sisusb xserver-xorg-video-tdfx
  xserver-xorg-video-tga xserver-xorg-video-trident xserver-xorg-video-tseng xserver-xorg-video-v4l xserver-xorg-video-vesa
  xserver-xorg-video-vga xserver-xorg-video-via xserver-xorg-video-vmware xserver-xorg-video-voodoo
0 upgraded, 49 newly installed, 0 to remove and 0 not upgraded.
3 not fully installed or removed.
Need to get 9009kB of archives.
After unpacking 30.2MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~# aptitude install xserver-xorg-input-mouse xserver-xorg-input-kbd xserver-xorg-video-intel
Reading package lists... Done
Building dependency tree... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-video-all xserver-xorg-video-apm xserver-xorg-video-ark xserver-xorg-video-ati
  xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-cyrix xserver-xorg-video-dummy
  xserver-xorg-video-fbdev xserver-xorg-video-glint xserver-xorg-video-i128 xserver-xorg-video-i810 xserver-xorg-video-mga
  xserver-xorg-video-neomagic xserver-xorg-video-nv xserver-xorg-video-rendition xserver-xorg-video-s3
  xserver-xorg-video-s3virge xserver-xorg-video-savage xserver-xorg-video-siliconmotion xserver-xorg-video-sis
  xserver-xorg-video-sisusb xserver-xorg-video-tdfx xserver-xorg-video-tga xserver-xorg-video-trident xserver-xorg-video-tseng
  xserver-xorg-video-v4l xserver-xorg-video-vesa xserver-xorg-video-vga xserver-xorg-video-via xserver-xorg-video-vmware
  xserver-xorg-video-voodoo
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable
Recommended packages:
  xserver-xorg-input-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-mouse xserver-xorg-video-all xserver-xorg-video-apm xserver-xorg-video-ark
  xserver-xorg-video-ati xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-cyrix xserver-xorg-video-dummy
  xserver-xorg-video-fbdev xserver-xorg-video-glint xserver-xorg-video-i128 xserver-xorg-video-i810 xserver-xorg-video-intel
  xserver-xorg-video-mga xserver-xorg-video-neomagic xserver-xorg-video-nv xserver-xorg-video-rendition xserver-xorg-video-s3
  xserver-xorg-video-s3virge xserver-xorg-video-savage xserver-xorg-video-siliconmotion xserver-xorg-video-sis
  xserver-xorg-video-sisusb xserver-xorg-video-tdfx xserver-xorg-video-tga xserver-xorg-video-trident xserver-xorg-video-tseng
  xserver-xorg-video-v4l xserver-xorg-video-vesa xserver-xorg-video-vga xserver-xorg-video-via xserver-xorg-video-vmware
  xserver-xorg-video-voodoo
0 upgraded, 48 newly installed, 0 to remove and 0 not upgraded.
3 not fully installed or removed.
Need to get 8994kB of archives.
After unpacking 30.0MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~# apt-get install xserver-xorg-video-intel
Reading package lists... Done
Building dependency tree... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-kbd
  xserver-xorg-input-mouse xserver-xorg-input-synaptics xserver-xorg-input-wacom
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable gsynaptics ksynaptics qsynaptics
Recommended packages:
  xserver-xorg-video-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-kbd
  xserver-xorg-input-mouse xserver-xorg-input-synaptics xserver-xorg-input-wacom xserver-xorg-video-intel
0 upgraded, 21 newly installed, 0 to remove and 0 not upgraded.
3 not fully installed or removed.
Need to get 7020kB of archives.
After unpacking 24.1MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~# 
Script done on Sat 02 Jun 2007 11:06:25 PM CEST
Script started on Sun 03 Jun 2007 12:02:51 AM CEST
gismo:~# apt-get install xserver-xorg-video-intel xserver-xorg-input-mouse xserver-xorg-input-kbd
Reading package lists... Done
Building dependency tree... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-synaptics
  xserver-xorg-input-wacom
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable gsynaptics ksynaptics qsynaptics
Recommended packages:
  xserver-xorg-video-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-kbd
  xserver-xorg-input-mouse xserver-xorg-input-synaptics xserver-xorg-input-wacom xserver-xorg-video-intel
0 upgraded, 21 newly installed, 0 to remove and 4 not upgraded.
3 not fully installed or removed.
Need to get 7026kB of archives.
After unpacking 24.1MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~# apt-get install xserver-xorg-video-intel xserver-xorg-input-kbd xserver-xorg-input-mouse
Reading package lists... Done
Building dependency tree... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-synaptics
  xserver-xorg-input-wacom
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable gsynaptics ksynaptics qsynaptics
Recommended packages:
  xserver-xorg-video-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core xserver-xorg-input-all xserver-xorg-input-evdev xserver-xorg-input-kbd
  xserver-xorg-input-mouse xserver-xorg-input-synaptics xserver-xorg-input-wacom xserver-xorg-video-intel
0 upgraded, 21 newly installed, 0 to remove and 4 not upgraded.
3 not fully installed or removed.
Need to get 7026kB of archives.
After unpacking 24.1MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~# dget xserver-xorg-video-intel
dget: retrieving http://ftp.ch.debian.org/debian//pool/main/x/xserver-xorg-video-intel/xserver-xorg-video-intel_2.0.0-1_amd64.deb
[...]
00:03:50 (459.83 KB/s) - `xserver-xorg-video-intel_2.0.0-1_amd64.deb' saved [284386/284386]

gismo:~# dget xserver-xorg-input-kbd
dget: retrieving http://ftp.ch.debian.org/debian//pool/main/x/xserver-xorg-input-keyboard/xserver-xorg-input-kbd_1.1.0-4_amd64.deb
[...]
00:04:02 (294.65 MB/s) - `xserver-xorg-input-kbd_1.1.0-4_amd64.deb' saved [14830/14830]

gismo:~# dget xserver-xorg-input-mouse
dget: retrieving http://ftp.ch.debian.org/debian//pool/main/x/xserver-xorg-input-mouse/xserver-xorg-input-mouse_1.1.1-3_amd64.deb
[...]
00:04:14 (1.21 MB/s) - `xserver-xorg-input-mouse_1.1.1-3_amd64.deb' saved [37876/37876]

gismo:~# ls *.deb
xserver-xorg-input-kbd_1.1.0-4_amd64.deb    xserver-xorg-video-intel_2.0.0-1_amd64.deb
xserver-xorg-input-mouse_1.1.1-3_amd64.deb
gismo:~# dpkg -i *.deb
Selecting previously deselected package xserver-xorg-input-kbd.
(Reading database ... 30781 files and directories currently installed.)
Unpacking xserver-xorg-input-kbd (from xserver-xorg-input-kbd_1.1.0-4_amd64.deb) ...
Selecting previously deselected package xserver-xorg-input-mouse.
Unpacking xserver-xorg-input-mouse (from xserver-xorg-input-mouse_1.1.1-3_amd64.deb) ...
Selecting previously deselected package xserver-xorg-video-intel.
Unpacking xserver-xorg-video-intel (from xserver-xorg-video-intel_2.0.0-1_amd64.deb) ...
dpkg: dependency problems prevent configuration of xserver-xorg-input-kbd:
 xserver-xorg-input-kbd depends on xserver-xorg-core (>= 2:1.1.1-4); however:
  Package xserver-xorg-core is not installed.
dpkg: error processing xserver-xorg-input-kbd (--install):
 dependency problems - leaving unconfigured
dpkg: dependency problems prevent configuration of xserver-xorg-input-mouse:
 xserver-xorg-input-mouse depends on xserver-xorg-core (>= 2:1.1.1-1); however:
  Package xserver-xorg-core is not installed.
dpkg: error processing xserver-xorg-input-mouse (--install):
 dependency problems - leaving unconfigured
dpkg: dependency problems prevent configuration of xserver-xorg-video-intel:
 xserver-xorg-video-intel depends on xserver-xorg-core (>= 2:1.3.0.0); however:
  Package xserver-xorg-core is not installed.
dpkg: error processing xserver-xorg-video-intel (--install):
 dependency problems - leaving unconfigured
Errors were encountered while processing:
 xserver-xorg-input-kbd
 xserver-xorg-input-mouse
 xserver-xorg-video-intel

gismo:~# apt-get -f install
Reading package lists... Done
Building dependency tree... Done
Correcting dependencies... Done
The following extra packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core
Suggested packages:
  mesa-utils xfonts-100dpi xfonts-75dpi xfonts-scalable
Recommended packages:
  xserver-xorg-video-all xserver-xorg-input-all xresprobe mdetect discover1 discover xfonts-base
The following NEW packages will be installed:
  libfontenc1 libfs6 libxfont1 libxkbfile1 libxmuu1 libxss1 libxtrap6 libxtst6 libxv1 libxxf86dga1 xbase-clients xkb-data
  xserver-xorg xserver-xorg-core
0 upgraded, 14 newly installed, 0 to remove and 4 not upgraded.
6 not fully installed or removed.
Need to get 6521kB of archives.
After unpacking 22.6MB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.
gismo:~# 
Script done on Sun 03 Jun 2007 12:04:46 AM CEST
--8<---------------cut here---------------end--------------->8---

Thx, bye,
Gismo / Luca

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (990, 'unstable'), (500, 'testing'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.22-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages apt depends on:
ii  debian-archive-keyring        2007.07.31 GnuPG archive keys of the Debian a
ii  libc6                         2.6-5      GNU C Library: Shared libraries
ii  libgcc1                       1:4.2.1-1  GCC support library
ii  libstdc++6                    4.2.1-1    The GNU Standard C++ Library v3

apt recommends no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to russell@coker.com.au:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 435662@bugs.debian.org (full text, mbox):

From: Russell Coker <russell@coker.com.au>
To: Luca Capello <luca@pca.it>
Cc: 435662@bugs.debian.org
Subject: Re: Russell Coker: SE Linux Policy Packaging for a Distribution
Date: Wed, 20 Aug 2008 09:19:26 +1000
On Wednesday 20 August 2008 05:48, Luca Capello <luca@pca.it> wrote:
> > I suspect that most Debian systems have all the video driver packages
> > installed (along with drivers for wacom tablets and other hardware
> > devices that might be used) as that appears to be the default.
>
> A bug in apt-get/aptitude prevents this "default" to be unset, please
> read http://bugs.debian.org/435662.

It doesn't look like an apt bug to me.

xserver-xorg-video-intel depends on xserver-xorg-core which depends on 
xserver-xorg which depends on xserver-xorg-video-all and 
xserver-xorg-input-all.

It looks like a dependency problem in the xorg packages.





Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 435662@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: russell@coker.com.au
Cc: 435662@bugs.debian.org
Subject: Re: Russell Coker: SE Linux Policy Packaging for a Distribution
Date: Wed, 20 Aug 2008 01:37:50 +0200
[Message part 1 (text/plain, inline)]
Hi Russel!

On Wed, 20 Aug 2008 01:19:26 +0200, Russell Coker wrote:
> On Wednesday 20 August 2008 05:48, Luca Capello <luca@pca.it> wrote:
>> > I suspect that most Debian systems have all the video driver packages
>> > installed (along with drivers for wacom tablets and other hardware
>> > devices that might be used) as that appears to be the default.
>>
>> A bug in apt-get/aptitude prevents this "default" to be unset, please
>> read http://bugs.debian.org/435662.
>
> It doesn't look like an apt bug to me.
>
> xserver-xorg-video-intel depends on xserver-xorg-core which depends on 
> xserver-xorg which depends on xserver-xorg-video-all and 
> xserver-xorg-input-all.
>
> It looks like a dependency problem in the xorg packages.

No, the dependencies in the xorg packages are correct, please check the
alternative dependencies and what's the -video-* and -input-* packages
provide:

=====
luca@gismo:~$ dpkg -s xserver-xorg-video-intel | grep Depends
Depends: libc6 (>= 2.7-1), libdrm2 (>= 2.3.1), xserver-xorg-core (>= 2:1.4)

luca@gismo:~$ dpkg -s xserver-xorg-video-intel | grep Provides
Provides: xserver-xorg-video-2

luca@gismo:~$ dpkg -s xserver-xorg-input-kbd | grep Depends
Depends: libc6 (>= 2.7-1), xserver-xorg-core (>= 2:1.4)

luca@gismo:~$ dpkg -s xserver-xorg-input-kbd | grep Provides
Provides: xserver-xorg-input-2

luca@gismo:~$ dpkg -s xserver-xorg-input-mouse | grep Depends
Depends: libc6 (>= 2.7-1), xserver-xorg-core (>= 2:1.4)

luca@gismo:~$ dpkg -s xserver-xorg-input-mouse | grep Provides
Provides: xserver-xorg-input-2

luca@gismo:~$ dpkg -s xserver-xorg-core | grep Depends
Depends: x11-common (>= 1:7.0.0), libc6 (>= 2.7-1), libdbus-1-3 (>= 1.0.2), \
 libdrm2 (>= 2.3.1), libfontenc1, libhal1 (>= 0.5.8.1), libpixman-1-0, \
 libxau6, libxdmcp6, libxfont1 (>= 1:1.2.9), xserver-xorg

luca@gismo:~$ dpkg -s xserver-xorg | grep Depends
Depends: xserver-xorg-core (>= 2:1.4-3), xserver-xorg-video-all | xserver-xorg-video-2, \
 xserver-xorg-input-all | xserver-xorg-input-2, libc6 (>= 2.7-1), \
 debconf (>= 0.5) | debconf-2.0, xkb-data | xkb-data-legacy, x11-xkb-utils

luca@gismo:~$
=====

If the problem would be the dependencies in the xorg packages, I
couldn't manually install the single -video-intel, -input-kbd and
-input-mouse packages and then the rest through `apt-get -f install`.

Maybe xserver-xorg should firsty depend on -video-2 and then
on -video-all, the same for -input-2 and -input-all?

BTW, this is particular annoying since when installing Debian on the
Opemoko FreeRunner [1], we need to first install all the -video-* and
-input-* packages and then remove them [2].

Thx, bye,
Gismo / Luca

Footnotes: 
[1] http://wiki.debian.org/DebianOnFreeRunner
[2] http://git.debian.org/?p=pkg-fso/files.git;a=blob;f=install.sh
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Josip Rodin <joy@debbugs.entuzijast.net>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 435662@bugs.debian.org (full text, mbox):

From: Josip Rodin <joy@debbugs.entuzijast.net>
To: 435662@bugs.debian.org
Cc: debian-x@lists.debian.org
Subject: xserver-xorg-video-all vs. -1.0 distinction breaks on upgrades to -2
Date: Sun, 7 Sep 2008 22:32:29 +0200
Hi,

I have xserver-xorg-video-nv installed, because that's the only xorg video
driver that I need. I don't have all the other driver packages installed,
because there's unnecessary.

The etch->lenny upgrade nevertheless says:

The following NEW packages will be installed:
[...]
  xserver-xorg-video-all xserver-xorg-video-apm xserver-xorg-video-ark
  xserver-xorg-video-ati xserver-xorg-video-chips xserver-xorg-video-cirrus
  xserver-xorg-video-cyrix xserver-xorg-video-dummy xserver-xorg-video-fbdev
  xserver-xorg-video-glint xserver-xorg-video-i128 xserver-xorg-video-intel
  xserver-xorg-video-mach64 xserver-xorg-video-mga
  xserver-xorg-video-neomagic
  xserver-xorg-video-openchrome xserver-xorg-video-r128
  xserver-xorg-video-radeon xserver-xorg-video-radeonhd
  xserver-xorg-video-rendition xserver-xorg-video-s3
  xserver-xorg-video-s3virge xserver-xorg-video-savage
  xserver-xorg-video-siliconmotion xserver-xorg-video-sis
  xserver-xorg-video-sisusb xserver-xorg-video-tdfx xserver-xorg-video-tga
  xserver-xorg-video-trident xserver-xorg-video-tseng xserver-xorg-video-v4l
  xserver-xorg-video-vesa xserver-xorg-video-vga xserver-xorg-video-vmware
  xserver-xorg-video-voodoo xulrunner-1.9
The following packages will be upgraded:
[...]
  xserver-xorg xserver-xorg-core xserver-xorg-input-evdev
  xserver-xorg-input-kbd xserver-xorg-input-mouse xserver-xorg-video-nv
[...]

This is bad because:

Package: xserver-xorg
Version: 1:7.3+15
Depends: xserver-xorg-core (>= 2:1.4-3), xserver-xorg-video-all | xserver-xorg-video-2, [...]

xserver-xorg-video-nv used to provide the xserver-xorg-video-1.0 virtual
package, and now the new version provides the xserver-xorg-video-2 virtual
package. But apt isn't catching on to the idea - it's ignoring the fact
that it can obtain xserver-xorg-video-2 simply by upgrading
xserver-xorg-video-nv. Instead it is parsing the dependency list as if it's
in a vacuum, seeing that xserver-xorg-video-2 isn't there, and therefore
installing xserver-xorg-video-all.

In a simple A | B dependency, package A clearly takes precedence, that's
what the rules say. But that is oriented towards the new installs.
On upgrades, if B is obtained a) from an already installed package, just
a new version of it b) at a visibly smaller cost -- then that should be
taken into consideration.

As a workaround, I'd just purge xserver-xorg and be done with it.
But xserver-xorg-core depends on it for some reason. The reason seems
to be http://bugs.debian.org/392295 Surely this could have been fixed
by putting that part of code into the xserver-xorg-core package instead
of creating a dependency which is circular?

(The same behaviour seems to apply to both apt-get and aptitude.)

-- 
     2. That which causes joy or happiness.




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Josip Rodin <joy@debbugs.entuzijast.net>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 435662@bugs.debian.org (full text, mbox):

From: Josip Rodin <joy@debbugs.entuzijast.net>
To: 435662@bugs.debian.org
Cc: debian-x@lists.debian.org, 362313@bugs.debian.org, 396613@bugs.debian.org
Subject: Re: xserver-xorg-video-all vs. -1.0 distinction breaks on upgrades to -2
Date: Sun, 7 Sep 2008 22:43:34 +0200
On Sun, Sep 07, 2008 at 10:32:29PM +0200, Josip Rodin wrote:
> xserver-xorg-video-nv used to provide the xserver-xorg-video-1.0 virtual
> package, and now the new version provides the xserver-xorg-video-2 virtual
> package. But apt isn't catching on to the idea - it's ignoring the fact
> that it can obtain xserver-xorg-video-2 simply by upgrading
> xserver-xorg-video-nv. Instead it is parsing the dependency list as if it's
> in a vacuum, seeing that xserver-xorg-video-2 isn't there, and therefore
> installing xserver-xorg-video-all.
> 
> In a simple A | B dependency, package A clearly takes precedence, that's
> what the rules say. But that is oriented towards the new installs.
> On upgrades, if B is obtained a) from an already installed package, just
> a new version of it b) at a visibly smaller cost -- then that should be
> taken into consideration.
> 
> As a workaround, I'd just purge xserver-xorg and be done with it.
> But xserver-xorg-core depends on it for some reason. The reason seems
> to be http://bugs.debian.org/392295 Surely this could have been fixed
> by putting that part of code into the xserver-xorg-core package instead
> of creating a dependency which is circular?

Apparently this is discussed in http://bugs.debian.org/362313
and there's also http://bugs.debian.org/396613

I don't seem to see any reason for all that $SERVER_SYMLINK code. Why do we
still have shared/default-x-server debconf stuff if xserver-xfree86 has been
removed from lenny?

And even so, wouldn't it be wiser to (also) handle that symlink in
the xserver-xorg-core package which actually provides the
/usr/bin/Xorg binary the link points to, rather than the meta package?

-- 
     2. That which causes joy or happiness.




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Josip Rodin <joy@debbugs.entuzijast.net>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 435662@bugs.debian.org (full text, mbox):

From: Josip Rodin <joy@debbugs.entuzijast.net>
To: 435662@bugs.debian.org
Cc: debian-x@lists.debian.org, 362313@bugs.debian.org, 396613@bugs.debian.org
Subject: Re: xserver-xorg-video-all vs. -1.0 distinction breaks on upgrades to -2
Date: Sun, 7 Sep 2008 22:55:55 +0200
On Sun, Sep 07, 2008 at 10:43:34PM +0200, Josip Rodin wrote:
> > As a workaround, I'd just purge xserver-xorg and be done with it.
> > But xserver-xorg-core depends on it for some reason. The reason seems
> > to be http://bugs.debian.org/392295 Surely this could have been fixed
> > by putting that part of code into the xserver-xorg-core package instead
> > of creating a dependency which is circular?
> 
> Apparently this is discussed in http://bugs.debian.org/362313
> and there's also http://bugs.debian.org/396613
> 
> I don't seem to see any reason for all that $SERVER_SYMLINK code. Why do we
> still have shared/default-x-server debconf stuff if xserver-xfree86 has been
> removed from lenny?
> 
> And even so, wouldn't it be wiser to (also) handle that symlink in
> the xserver-xorg-core package which actually provides the
> /usr/bin/Xorg binary the link points to, rather than the meta package?

The Lintian laboratory on l.d.o can't find me any other packages' postinsts
referencing shared/default-x-server. And xserver-xfree86 was actually
a transitional package in etch already. So I have no idea why this whole
complication exists in there.

-- 
     2. That which causes joy or happiness.




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 435662@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Josip Rodin <joy@debbugs.entuzijast.net>
Cc: 435662@bugs.debian.org, debian-x@lists.debian.org, 362313@bugs.debian.org, 396613@bugs.debian.org
Subject: Re: xserver-xorg-video-all vs. -1.0 distinction breaks on upgrades to -2
Date: Sun, 7 Sep 2008 23:58:25 +0100
On Sun, Sep  7, 2008 at 22:55:55 +0200, Josip Rodin wrote:

> The Lintian laboratory on l.d.o can't find me any other packages' postinsts
> referencing shared/default-x-server. And xserver-xfree86 was actually
> a transitional package in etch already. So I have no idea why this whole
> complication exists in there.
> 
Hysterical raisins.  It should be removed at some point; patches
welcome, although not for lenny.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Josip Rodin <joy@debbugs.entuzijast.net>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 435662@bugs.debian.org (full text, mbox):

From: Josip Rodin <joy@debbugs.entuzijast.net>
To: 435662@bugs.debian.org, debian-x@lists.debian.org, 362313@bugs.debian.org, 396613@bugs.debian.org
Subject: Re: xserver-xorg-video-all vs. -1.0 distinction breaks on upgrades to -2
Date: Mon, 8 Sep 2008 01:15:42 +0200
On Sun, Sep 07, 2008 at 11:58:25PM +0100, Julien Cristau wrote:
> > The Lintian laboratory on l.d.o can't find me any other packages' postinsts
> > referencing shared/default-x-server. And xserver-xfree86 was actually
> > a transitional package in etch already. So I have no idea why this whole
> > complication exists in there.
> 
> Hysterical raisins.  It should be removed at some point; patches
> welcome, although not for lenny.

Well, it's severely impairing my upgrade *to* lenny, so I wager it's
an issue for lenny :)

Are there any external packages known to provide the symlink? ISTR some
external X server software, but I don't know if it has deb packages.

If not, is there any reason why this couldn't be a symlink shipped by
xserver-xorg-core, or an ln -s invocation in its postinst? IIRC we stopped
supporting 'jumping' upgrades (e.g. sarge->lenny) so we don't really care
if we break that old xserver-xfree86.

My point being - in that case, the patches are pretty simple.

-- 
     2. That which causes joy or happiness.




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. (Mon, 11 May 2009 12:57:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Mon, 11 May 2009 12:57:11 GMT) Full text and rfc822 format available.

Message #45 received at 435662@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: 435662@bugs.debian.org
Subject: Re: Russell Coker: SE Linux Policy Packaging for a Distribution
Date: Mon, 11 May 2009 14:51:21 +0200
[Message part 1 (text/plain, inline)]
Hi there!

BTW, this is *not* a bug in any X.Org package, but in apt/aptitude.
When not specified, aptitude does the same as apt-get.

On Wed, 20 Aug 2008 01:37:50 +0200, Luca Capello wrote:
> BTW, this is particular annoying since when installing Debian on the
> Opemoko FreeRunner [1], we need to first install all the -video-* and
> -input-* packages and then remove them [2].
[...]
> Footnotes: 
> [1] http://wiki.debian.org/DebianOnFreeRunner
> [2] http://git.debian.org/?p=pkg-fso/files.git;a=blob;f=install.sh

The situation has evolved WRT X.Org after the new X.Org dependency on
HAL/kbd as per

  http://bugs.debian.org/515214


1) on my ThinkPad X60, with install-recommends false and kbd already
   installed (around mid-April 2009, but not checked with aptitude):
   =====
   gismo:~# apt-get install xserver-xorg-video-intel
   [...]
   The following extra packages will be installed:
     acl consolekit hal libaudit0 libck-connector0 libdrm-intel1
     libfontenc1 libpciaccess0 libpolkit-dbus2 libpolkit-grant2
     libpolkit2 libxaw7 libxfont1 libxkbfile1 libxmu6 policykit
     x11-xkb-utils xserver-common xserver-xorg xserver-xorg-core
     xserver-xorg-input-evdev
   [...]

   gismo:~# apt-get install xserver-xorg
   [...]
   The following extra packages will be installed:
     acl consolekit hal libaudit0 libck-connector0 libdrm-intel1
     libfontenc1 libpciaccess0 libpolkit-dbus2 libpolkit-grant2
     libpolkit2 libxaw7 libxfont1 libxkbfile1 libxmu6 policykit
     x11-xkb-utils xserver-common xserver-xorg-core
     xserver-xorg-input-evdev xserver-xorg-video-all
     xserver-xorg-video-apm xserver-xorg-video-ark
     xserver-xorg-video-ati xserver-xorg-video-chips
     xserver-xorg-video-cirrus xserver-xorg-video-fbdev
     xserver-xorg-video-i128 xserver-xorg-video-intel
     xserver-xorg-video-mach64 xserver-xorg-video-mga
     xserver-xorg-video-neomagic xserver-xorg-video-nv
     xserver-xorg-video-openchrome xserver-xorg-video-r128
     xserver-xorg-video-radeon xserver-xorg-video-radeonhd
     xserver-xorg-video-rendition xserver-xorg-video-s3
     xserver-xorg-video-s3virge xserver-xorg-video-savage
     xserver-xorg-video-siliconmotion xserver-xorg-video-sis
     xserver-xorg-video-sisusb xserver-xorg-video-tdfx
     xserver-xorg-video-trident xserver-xorg-video-tseng
     xserver-xorg-video-v4l xserver-xorg-video-vesa
     xserver-xorg-video-vmware xserver-xorg-video-voodoo
   [...]

   gismo:~#
   =====


2) apt-get on a clean chroot created by cdebootstrap my Openmoko
   FreeRunner, again with install-recommends false:
   =====
   root@om-gta02:/# apt-get install xserver-xorg-video-fbdev
   [...]
   The following extra packages will be installed:
     acl console-common console-data console-setup console-terminus
     consolekit cpp cpp-4.3 dbus gcc-4.3-base hal hal-info kbd libaudit0
     libck-connector0 libdbus-1-3 libdbus-glib-1-2 libdrm2 libexpat1
     libfontenc1 libfreetype6 libgcrypt11 libglib2.0-0 libgmp3c2
     libgpg-error0 libhal-storage1 libhal1 libice6 libmpfr1ldbl libpci3
     libpciaccess0 libpcre3 libpixman-1-0 libpolkit-dbus2
     libpolkit-grant2 libpolkit2 libsm6 libx11-6 libx11-data libxau6
     libxaw7 libxcb1 libxdmcp6 libxext6 libxfont1 libxkbfile1 libxmu6
     libxpm4 libxt6 pciutils pm-utils policykit powermgmt-base usbutils
     x11-common x11-xkb-utils xkb-data xserver-common xserver-xorg
     xserver-xorg-core xserver-xorg-input-evdev
   [...]

   root@om-gta02:/# apt-get install xserver-xorg
   [...]
   The following extra packages will be installed:
     acl console-common console-data console-setup console-terminus
     consolekit cpp cpp-4.3 dbus gcc-4.3-base hal hal-info kbd libaudit0
     libck-connector0 libdbus-1-3 libdbus-glib-1-2 libdrm2 libexpat1
     libfontenc1 libfreetype6 libgcrypt11 libglib2.0-0 libgmp3c2
     libgpg-error0 libhal-storage1 libhal1 libice6 libmpfr1ldbl libpci3
     libpciaccess0 libpcre3 libpixman-1-0 libpolkit-dbus2
     libpolkit-grant2 libpolkit2 libsm6 libx11-6 libx11-data libxau6
     libxaw7 libxcb1 libxdmcp6 libxext6 libxfont1 libxkbfile1 libxmu6
     libxpm4 libxt6 pciutils pm-utils policykit powermgmt-base usbutils
     x11-common x11-xkb-utils xkb-data xserver-common xserver-xorg-core
     xserver-xorg-input-evdev xserver-xorg-video-all
     xserver-xorg-video-apm xserver-xorg-video-ark
     xserver-xorg-video-ati xserver-xorg-video-chips
     xserver-xorg-video-cirrus xserver-xorg-video-fbdev
     xserver-xorg-video-i128 xserver-xorg-video-i740
     xserver-xorg-video-mach64 xserver-xorg-video-mga
     xserver-xorg-video-neomagic xserver-xorg-video-nv
     xserver-xorg-video-r128 xserver-xorg-video-radeon
     xserver-xorg-video-radeonhd xserver-xorg-video-rendition
     xserver-xorg-video-s3 xserver-xorg-video-s3virge
     xserver-xorg-video-savage xserver-xorg-video-siliconmotion
     xserver-xorg-video-sis xserver-xorg-video-sisusb
     xserver-xorg-video-tdfx xserver-xorg-video-trident
     xserver-xorg-video-tseng xserver-xorg-video-v4l
     xserver-xorg-video-vesa xserver-xorg-video-voodoo
   [...]

   root@om-gta02:/#
   =====


3) aptitude on the same chroot as above:
   =====
   root@om-gta02:/# aptitude install xserver-xorg-video-fbdev
   [...]
   The following NEW packages will be installed:
     acl{a} console-common{a} console-data{a} console-setup{a} console-terminus{a}
     consolekit{a} cpp{a} cpp-4.3{a} dbus{a} gcc-4.3-base{a} hal{a} hal-info{a} kbd{a} libaudit0{a}
     libck-connector0{a} libdbus-1-3{a} libdbus-glib-1-2{a} libdrm2{a} libexpat1{a}
     libfontenc1{a} libfreetype6{a} libgcrypt11{a} libglib2.0-0{a} libgmp3c2{a}
     libgpg-error0{a} libhal-storage1{a} libhal1{a} libice6{a} libmpfr1ldbl{a} libpci3{a}
     libpciaccess0{a} libpcre3{a} libpixman-1-0{a} libpolkit-dbus2{a}
     libpolkit-grant2{a} libpolkit2{a} libsm6{a} libx11-6{a} libx11-data{a} libxau6{a}
     libxaw7{a} libxcb1{a} libxdmcp6{a} libxext6{a} libxfont1{a} libxkbfile1{a} libxmu6{a}
     libxpm4{a} libxt6{a} pciutils{a} pm-utils{a} policykit{a} powermgmt-base{a} usbutils{a}
     x11-common{a} x11-xkb-utils{a} xkb-data{a} xserver-common{a} xserver-xorg{a}
     xserver-xorg-core{a} xserver-xorg-input-evdev{a}
     xserver-xorg-video-fbdev
   [...]

   root@om-gta02:/#
   =====


While people can now choose a single xserver-xorg-video-* package,
however the apt/aptitude bug is still there, only now related to the
console-* packages.  This because of:

- kbd depends on "console-common | console-setup"

- console-common depends on both "console-data, kbd | console-tools"

- xserver-xorg depends on "console-setup"
    http://bugs.debian.org/523960

Thus, if I install *both* kbd and xserver-xorg, I do not need
console-common (and the dependent console-data).  However, apt (and
aptitude as well) still wants to install it.  This is indeed a bug.


However, while looking at the situation in more details I discovered a
second bug, this time restricted to apt only.  Since now on the
"offending" package is kbd.


1) for apt-get, the order in which packages are asked to be installed
   counts:
   =====
   root@om-gta02:/# apt-get install kbd
   [...]
   The following extra packages will be installed:
     console-common console-data
   [...]

   root@om-gta02:/# apt-get install kbd console-setup
   [...]
   The following extra packages will be installed:
     console-common console-data console-terminus xkb-data
   [...]

   root@om-gta02:/# apt-get install console-setup kbd
   [...]
   The following extra packages will be installed:
     console-terminus xkb-data
   [...]

   root@om-gta02:/#
   =====


2) apt-get behaves correctly if asked to remove the not-needed package:
   =====
   root@om-gta02:/# apt-get install kbd console-data-
   [...]
   Package console-data is not installed, so not removed
   The following extra packages will be installed:
     console-setup console-terminus xkb-data
   [...]

   root@om-gta02:/#
   =====


3) aptitude correctly resolves the dependencies when explicitly asked,
   independently of the package order:
   =====
   root@om-gta02:/# aptitude install kbd
   [...]
   The following NEW packages will be installed:
     console-common{a} console-data{a} kbd
   [...]

   root@om-gta02:/# aptitude install kbd console-setup
   [...]
   The following NEW packages will be installed:
     console-setup console-terminus{a} kbd xkb-data{a}
   [...]

   root@om-gta02:/#
   =====


Note that because of this second bug, if someone (like the Debian
FreeSmartphone.Org team) wants to install one single
xserver-xorg-video-* package avoiding the console-data installation,
this has to be done with:

  # apt-get install xserver-xorg-video-fbdev console-data-

or

  # aptitude install xserver-xorg-video-fbdev console-setup


Thx, bye,
Gismo / Luca
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. (Sun, 17 Jan 2010 16:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Sun, 17 Jan 2010 16:39:02 GMT) Full text and rfc822 format available.

Message #50 received at 435662@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: 435662@bugs.debian.org
Subject: apt: differences between upgrade and install
Date: Sun, 17 Jan 2010 17:36:46 +0100
[Message part 1 (text/plain, inline)]
Hi there!

This bug is still not solved, and today I discovered a discrepancy WRT
upgrade and install.

The background: because of bug #557885 [1], I do not want to update cups
before the xpdf/poppler mess is fixed [2].  I know I can put packages on
hold, but I prefer to simply check what is to be upgraded and then pass
it to `apt-get install`.

This revealed the following discrepancy between `apt-get upgrade` and
`apt-get install`:

--8<---------------cut here---------------start------------->8---
gismo:~# apt-get upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
The following packages have been kept back:
  bibtool cups dictd dictzip dvipng keynav libjpeg-progs librdf0 linux-image-2.6-amd64 qemu-kvm qemu-system tex-common tex4ht
  texlive-base texlive-common texlive-doc-base texlive-doc-en texlive-fonts-recommended texlive-generic-recommended
  texlive-latex-base texlive-latex-extra texlive-latex-recommended texlive-pictures texlive-pstricks texlive-science
The following packages will be upgraded:
  acpid apt apt-utils avahi-daemon binutils console-setup consolekit coreutils cpp-4.4 cups-bsd cups-client cups-common
  dhcp3-client dhcp3-common dict-wn dpkg dpkg-dev emacs-snapshot emacs-snapshot-bin-common emacs-snapshot-common
  emacs-snapshot-el gcc-4.4 gcc-4.4-base gimp gimp-data gnupg-agent grub-common grub-pc gthumb guile-1.6-libs hostname irb1.8
  keyboard-configuration libavahi-client3 libavahi-common-data libavahi-common3 libavahi-core6 libavahi-glib1 libbsd0
  libc-bin libc-dev-bin libc6 libc6-dev libc6-i386 libck-connector0 libconsole libcups2 libcupscgi1 libcupsdriver1
  libcupsimage2 libcupsmime1 libcupsppdc1 libdaemon0 libdatrie1 libdpkg-ruby1.8 libgail18 libgcc1 libgeoip1 libgfortran3
  libgif4 libgimp2.0 libgirepository1.0-0 libglib2.0-0 libgmp3c2 libgomp1 libgssapi-krb5-2 libgssrpc4 libgtk2.0-0
  libgtk2.0-common libgtkspell0 libgudev-1.0-0 libguile-ltdl-1 libiptcdata0 libjack0 libjs-jquery libk5crypto3 libkdb5-4
  libkrb5-3 libkrb5support0 liblcms1 libmouse-perl libopenssl-ruby1.8 libpam-smbpass libpci3 libpng12-0 libpolkit-backend-1-0
  libpolkit-gobject-1-0 libquicktime1 libraw1394-11 libreadline-ruby1.8 libruby1.8 libsdl1.2debian libsdl1.2debian-alsa
  libsigc++-2.0-0c2a libsmbclient libsoup2.4-1 libssl0.9.8 libstdc++6 libthai-data libthai0 libtiff4 libtimedate-perl
  libudev0 liburi-perl libwbclient0 libx11-6 libx11-data linux-libc-dev locales mc mktemp nfs-common openoffice.org-base-core
  openoffice.org-calc openoffice.org-common openoffice.org-core openoffice.org-draw openoffice.org-impress
  openoffice.org-style-galaxy openoffice.org-writer openssh-client openssh-server openssl pciutils python-reportbug qemu
  qemu-user qemu-utils quilt reportbug ruby1.8 samba samba-common smbfs ttf-opensymbol udev uno-libs3 ure vim-common vim-tiny
  xbindkeys xkb-data xserver-common xserver-xorg xserver-xorg-core xserver-xorg-input-evdev xserver-xorg-video-intel
147 upgraded, 0 newly installed, 0 to remove and 25 not upgraded.
Need to get 248MB of archives.
After this operation, 1,290kB disk space will be freed.
Do you want to continue [Y/n]? n
Abort.

gismo:~# apt-get install \
 acpid apt apt-utils avahi-daemon binutils console-setup consolekit coreutils cpp-4.4 \
 dhcp3-client dhcp3-common dict-wn dpkg dpkg-dev emacs-snapshot emacs-snapshot-bin-common emacs-snapshot-common \
 emacs-snapshot-el gcc-4.4 gcc-4.4-base gimp gimp-data gnupg-agent grub-common grub-pc gthumb guile-1.6-libs hostname irb1.8 \
 keyboard-configuration libavahi-client3 libavahi-common-data libavahi-common3 libavahi-core6 libavahi-glib1 libbsd0 \
 libc-bin libc-dev-bin libc6 libc6-dev libc6-i386 libck-connector0 libconsole \
 libdaemon0 libdatrie1 libdpkg-ruby1.8 libgail18 libgcc1 libgeoip1 libgfortran3 \
 libgif4 libgimp2.0 libgirepository1.0-0 libglib2.0-0 libgmp3c2 libgomp1 libgssapi-krb5-2 libgssrpc4 libgtk2.0-0 \
 libgtk2.0-common libgtkspell0 libgudev-1.0-0 libguile-ltdl-1 libiptcdata0 libjack0 libjs-jquery libk5crypto3 libkdb5-4 \
 libkrb5-3 libkrb5support0 liblcms1 libmouse-perl libopenssl-ruby1.8 libpam-smbpass libpci3 libpng12-0 libpolkit-backend-1-0 \
 libpolkit-gobject-1-0 libquicktime1 libraw1394-11 libreadline-ruby1.8 libruby1.8 libsdl1.2debian libsdl1.2debian-alsa \
 libsigc++-2.0-0c2a libsmbclient libsoup2.4-1 libssl0.9.8 libstdc++6 libthai-data libthai0 libtiff4 libtimedate-perl \
 libudev0 liburi-perl libwbclient0 libx11-6 libx11-data linux-libc-dev locales mc mktemp nfs-common openoffice.org-base-core \
 openoffice.org-calc openoffice.org-common openoffice.org-core openoffice.org-draw openoffice.org-impress \
 openoffice.org-style-galaxy openoffice.org-writer openssh-client openssh-server openssl pciutils python-reportbug qemu \
 qemu-user qemu-utils quilt reportbug ruby1.8 samba samba-common smbfs ttf-opensymbol udev uno-libs3 ure vim-common vim-tiny \
 xbindkeys xkb-data xserver-common xserver-xorg xserver-xorg-core xserver-xorg-input-evdev xserver-xorg-video-intel
Reading package lists... Done
Building dependency tree
Reading state information... Done
The following extra packages will be installed:
  xserver-xorg-input-all xserver-xorg-input-synaptics xserver-xorg-input-wacom xserver-xorg-video-all xserver-xorg-video-apm
  xserver-xorg-video-ark xserver-xorg-video-ati xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-fbdev
  xserver-xorg-video-i128 xserver-xorg-video-mach64 xserver-xorg-video-mga xserver-xorg-video-neomagic xserver-xorg-video-nv
  xserver-xorg-video-openchrome xserver-xorg-video-r128 xserver-xorg-video-radeon xserver-xorg-video-radeonhd
  xserver-xorg-video-rendition xserver-xorg-video-s3 xserver-xorg-video-s3virge xserver-xorg-video-savage
  xserver-xorg-video-siliconmotion xserver-xorg-video-sis xserver-xorg-video-sisusb xserver-xorg-video-tdfx
  xserver-xorg-video-trident xserver-xorg-video-tseng xserver-xorg-video-v4l xserver-xorg-video-vesa
  xserver-xorg-video-vmware xserver-xorg-video-voodoo
Suggested packages:
  aptitude synaptic wajig apt-doc avahi-autoipd binutils-doc gcc-4.4-locales gcc-4.4-multilib libmudflap0-4.4-dev gcc-4.4-doc
  libgcc1-dbg libgomp1-dbg libmudflap0-dbg libcloog-ppl0 libppl-c2 libppl7 gimp-help-en gimp-help libgimp-perl
  gimp-data-extras gvfs-backends multiboot-doc grub-emu desktop-base glibc-doc geoip-bin krb5-doc krb5-user librsvg2-common
  jackd liblcms-utils libraw1394-doc arj dbview odt2txt catdvi djvulibre-bin python-boto python-tz openoffice.org-base
  openoffice.org-style-industrial openoffice.org-style-hicontrast openoffice.org-style-tango openoffice.org-style-crystal
  openoffice.org-style-oxygen openoffice.org-gcj ssh-askpass libpam-ssh keychain rssh molly-guard ufw qemu-user-static
  debootstrap graphviz debconf-utils debsums python-urwid python-vte python-gtkspell xdg-utils emacs22-bin-common
  emacs23-bin-common ruby1.8-examples rdoc1.8 ri1.8 smbldap-tools ldb-tools ctdb smbclient cli-uno-bridge indent wish
  xbindkeys-config xfonts-100dpi xfonts-75dpi xfonts-scalable gpointing-device-settings touchfreeze xinput firmware-linux
Recommended packages:
  acpi-support-base libpam-ck-connector build-essential os-prober gvfs-bin manpages-dev geoip-database libglib2.0-data
  hicolor-icon-theme libgtk2.0-bin javascript-common libclass-method-modifiers-perl xfonts-mathml
  openoffice.org-filter-binfilter default-jre gcj-jre java-gcj-compat openjdk-6-jre sun-java5-jre sun-java6-jre java5-runtime
  jre openoffice.org-java-common openoffice.org-emailmerge openoffice.org-math openssh-blacklist-extra samba-common-bin
  xfonts-base
The following NEW packages will be installed:
  xserver-xorg-input-all xserver-xorg-input-synaptics xserver-xorg-input-wacom xserver-xorg-video-all xserver-xorg-video-apm
  xserver-xorg-video-ark xserver-xorg-video-ati xserver-xorg-video-chips xserver-xorg-video-cirrus xserver-xorg-video-fbdev
  xserver-xorg-video-i128 xserver-xorg-video-mach64 xserver-xorg-video-mga xserver-xorg-video-neomagic xserver-xorg-video-nv
  xserver-xorg-video-openchrome xserver-xorg-video-r128 xserver-xorg-video-radeon xserver-xorg-video-radeonhd
  xserver-xorg-video-rendition xserver-xorg-video-s3 xserver-xorg-video-s3virge xserver-xorg-video-savage
  xserver-xorg-video-siliconmotion xserver-xorg-video-sis xserver-xorg-video-sisusb xserver-xorg-video-tdfx
  xserver-xorg-video-trident xserver-xorg-video-tseng xserver-xorg-video-v4l xserver-xorg-video-vesa
  xserver-xorg-video-vmware xserver-xorg-video-voodoo
The following packages will be upgraded:
  acpid apt apt-utils avahi-daemon binutils console-setup consolekit coreutils cpp-4.4 dhcp3-client dhcp3-common dict-wn dpkg
  dpkg-dev emacs-snapshot emacs-snapshot-bin-common emacs-snapshot-common emacs-snapshot-el gcc-4.4 gcc-4.4-base gimp
  gimp-data gnupg-agent grub-common grub-pc gthumb guile-1.6-libs hostname irb1.8 keyboard-configuration libavahi-client3
  libavahi-common-data libavahi-common3 libavahi-core6 libavahi-glib1 libbsd0 libc-bin libc-dev-bin libc6 libc6-dev
  libc6-i386 libck-connector0 libconsole libdaemon0 libdatrie1 libdpkg-ruby1.8 libgail18 libgcc1 libgeoip1 libgfortran3
  libgif4 libgimp2.0 libgirepository1.0-0 libglib2.0-0 libgmp3c2 libgomp1 libgssapi-krb5-2 libgssrpc4 libgtk2.0-0
  libgtk2.0-common libgtkspell0 libgudev-1.0-0 libguile-ltdl-1 libiptcdata0 libjack0 libjs-jquery libk5crypto3 libkdb5-4
  libkrb5-3 libkrb5support0 liblcms1 libmouse-perl libopenssl-ruby1.8 libpam-smbpass libpci3 libpng12-0 libpolkit-backend-1-0
  libpolkit-gobject-1-0 libquicktime1 libraw1394-11 libreadline-ruby1.8 libruby1.8 libsdl1.2debian libsdl1.2debian-alsa
  libsigc++-2.0-0c2a libsmbclient libsoup2.4-1 libssl0.9.8 libstdc++6 libthai-data libthai0 libtiff4 libtimedate-perl
  libudev0 liburi-perl libwbclient0 libx11-6 libx11-data linux-libc-dev locales mc mktemp nfs-common openoffice.org-base-core
  openoffice.org-calc openoffice.org-common openoffice.org-core openoffice.org-draw openoffice.org-impress
  openoffice.org-style-galaxy openoffice.org-writer openssh-client openssh-server openssl pciutils python-reportbug qemu
  qemu-user qemu-utils quilt reportbug ruby1.8 samba samba-common smbfs ttf-opensymbol udev uno-libs3 ure vim-common vim-tiny
  xbindkeys xkb-data xserver-common xserver-xorg xserver-xorg-core xserver-xorg-input-evdev xserver-xorg-video-intel
138 upgraded, 33 newly installed, 0 to remove and 34 not upgraded.
Need to get 250MB of archives.
After this operation, 6,975kB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.

gismo:~#
--8<---------------cut here---------------end--------------->8---

The solution is to put xserver-xorg at the end of the packages to be
installed, for the reasons explained before in this bug.

Thx, bye,
Gismo / Luca

Footnotes: 
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=557885
[2] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=409510#45

-- Package-specific info:

-- apt-config dump --

APT "";
APT::Architecture "amd64";
APT::Build-Essential "";
APT::Build-Essential:: "build-essential";
APT::Install-Recommends "false";
APT::Install-Suggests "0";
APT::Acquire "";
APT::Acquire::Translation "none";
APT::Authentication "";
APT::Authentication::TrustCDROM "true";
APT::NeverAutoRemove "";
APT::NeverAutoRemove:: "^linux-image.*";
APT::NeverAutoRemove:: "^linux-restricted-modules.*";
APT::NeverAutoRemove:: "^kfreebsd-image.*";
APT::Cache-Limit "88388604";
APT::Default-Release "unstable";
Dir "/";
Dir::State "var/lib/apt/";
Dir::State::lists "lists/";
Dir::State::cdroms "cdroms.list";
Dir::State::userstatus "status.user";
Dir::State::status "/var/lib/dpkg/status";
Dir::Cache "var/cache/apt/";
Dir::Cache::archives "archives/";
Dir::Cache::srcpkgcache "srcpkgcache.bin";
Dir::Cache::pkgcache "pkgcache.bin";
Dir::Etc "etc/apt/";
Dir::Etc::sourcelist "sources.list";
Dir::Etc::sourceparts "sources.list.d";
Dir::Etc::vendorlist "vendors.list";
Dir::Etc::vendorparts "vendors.list.d";
Dir::Etc::main "apt.conf";
Dir::Etc::netrc "auth.conf";
Dir::Etc::parts "apt.conf.d";
Dir::Etc::preferences "preferences";
Dir::Etc::preferencesparts "preferences.d";
Dir::Bin "";
Dir::Bin::methods "/usr/lib/apt/methods";
Dir::Bin::dpkg "/usr/bin/dpkg";
Dir::Log "var/log/apt";
Dir::Log::Terminal "term.log";
DPkg "";
DPkg::Pre-Invoke "";
DPkg::Pre-Invoke:: "if [ -x /usr/sbin/etckeeper ]; then etckeeper pre-install; fi";
DPkg::Post-Invoke "";
DPkg::Post-Invoke:: "if [ -x /usr/sbin/etckeeper ]; then etckeeper post-install; fi";
DPkg::Pre-Install-Pkgs "";
DPkg::Pre-Install-Pkgs:: "/usr/sbin/apt-listbugs apt || exit 10";
DPkg::Pre-Install-Pkgs:: "/usr/bin/apt-listchanges --apt || test $? -ne 10";
DPkg::Pre-Install-Pkgs:: "/usr/sbin/dpkg-preconfigure --apt || true";
DPkg::Tools "";
DPkg::Tools::Options "";
DPkg::Tools::Options::/usr/sbin/apt-listbugs "";
DPkg::Tools::Options::/usr/sbin/apt-listbugs::Version "2";
DPkg::Tools::Options::/usr/bin/apt-listchanges "";
DPkg::Tools::Options::/usr/bin/apt-listchanges::Version "2";
RPM "";
RPM::Pre-Invoke "";
RPM::Pre-Invoke:: "if [ -x /usr/sbin/etckeeper ]; then etckeeper pre-install; fi";
RPM::Post-Invoke "";
RPM::Post-Invoke:: "if [ -x /usr/sbin/etckeeper ]; then etckeeper post-install; fi";
Acquire "";
Acquire::PDiffs "false";

-- (no /etc/apt/preferences present) --


-- (no /etc/apt/sources.list present) --


-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (990, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.31-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages apt depends on:
ii  debian-archive-keyring        2009.01.31 GnuPG archive keys of the Debian a
ii  libc6                         2.10.2-4   Embedded GNU C Library: Shared lib
ii  libgcc1                       1:4.4.2-8  GCC support library
ii  libstdc++6                    4.4.2-8    The GNU Standard C++ Library v3

apt recommends no packages.

Versions of packages apt suggests:
pn  apt-doc                       <none>     (no description available)
pn  aptitude | synaptic | wajig   <none>     (no description available)
ii  bzip2                         1.0.5-3    high-quality block-sorting file co
ii  dpkg-dev                      1.15.5.5   Debian package development tools
ii  lzma                          4.43-14    Compression method of 7z format in
ii  python-apt                    0.7.13.4   Python interface to libapt-pkg

-- no debconf information
[Message part 2 (application/pgp-signature, inline)]

Reply sent to David Kalnischkies <kalnischkies@gmail.com>:
You have taken responsibility. (Wed, 14 Sep 2011 17:18:13 GMT) Full text and rfc822 format available.

Notification sent to Luca Capello <luca@pca.it>:
Bug acknowledged by developer. (Wed, 14 Sep 2011 17:18:13 GMT) Full text and rfc822 format available.

Message #55 received at 435662-done@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies@gmail.com>
To: 435662-done@bugs.debian.org
Subject: Close: apt: wants to install more packages even if the dependencies are satisfied
Date: Wed, 14 Sep 2011 19:16:41 +0200
Version: 0.7.26~exp8

APT doesn't care since that version in which order packages
are provided on the commandline, so
# apt-get install a b   and
# apt-get install b a
have the same result.

Further more, if 'a b' (or 'b a') is a valid solution to the
request APT will not try to install other packages.

See for both also #196021

So i consider this bug fixed, if not feel free to reopen!


Best regards

David Kalnischkies




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#435662; Package apt. (Wed, 14 Sep 2011 19:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Luca Capello <luca@pca.it>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Wed, 14 Sep 2011 19:15:03 GMT) Full text and rfc822 format available.

Message #60 received at 435662@bugs.debian.org (full text, mbox):

From: Luca Capello <luca@pca.it>
To: 435662@bugs.debian.org
Subject: Re: Bug#435662 closed by David Kalnischkies <kalnischkies@gmail.com> (Close: apt: wants to install more packages even if the dependencies are satisfied)
Date: Wed, 14 Sep 2011 21:12:01 +0200
[Message part 1 (text/plain, inline)]
Hi there!

On Wed, 14 Sep 2011 19:18:13 +0200, Debian Bug Tracking System wrote:
> This is an automatic notification regarding your Bug report
> which was filed against the apt package:
>
> #435662: apt: wants to install more packages even if the dependencies are satisfied
>
> It has been closed by David Kalnischkies <kalnischkies@gmail.com>.

On Mon, Wed, 14 Sep 2011 17:18:13 +0000, David Kalnischkies wrote:
> Version: 0.7.26~exp8

Tested with the version in unstable, thus 0.8.15.8.

> APT doesn't care since that version in which order packages
> are provided on the commandline

Confirmed...

> Further more, if 'a b' (or 'b a') is a valid solution to the
> request APT will not try to install other packages.

...and this as well.

> See for both also #196021
>
> So i consider this bug fixed, if not feel free to reopen!

Thank you, I am fully satisfied now ;-)

Thx, bye,
Gismo / Luca
[Message part 2 (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 13 Oct 2011 07:38:27 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 01:12:03 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.